{% extends "pghero/admin_base.html" %}


{% block breadcrumbs_extra %}
&rsaquo; Statuses
{% endblock breadcrumbs_extra %}


{% block content %}
<div id="content-main">
  <h1>Statuses</h1>

  <div class="module">
    <h2>Long Running Queries</h2>

    {% if good_cache_rate %}
      Cache hit rate above 99%
    {% else %}
      Low cache hit rate
    {% endif %}
  </div>

  <div class="module">
    <h2>Status</h2>

    {% with long_running_queries as object_list %}
      {% include "pghero/_queries_table.html" %}
    {% endwith %}
  </div>

  {% comment %}
  {# TODO: Clean this up #}
  <h1>Locks</h1>
  {{ locks }}
  {% endcomment %}

  <div class="module">
    <h2>Low Cache Hit Rate</h2>

    <p>
      Index Hit Rate: {{ index_hit_rate|floatformat:2 }}%
      <br>
      Table Hit Rate: {{ table_hit_rate|floatformat:2 }}%
    </p>
    <p>
      The cache hit rate <a href="https://devcenter.heroku.com/articles/understanding-postgres-data-caching" target="_blank">should be above 99%</a> in most cases.  You can often increase this by adding more memory.
    </p>
  </div>

  <div class="module">
    <h2>Missing Indexes</h2>

    <p>These tables have a large number of rows but indexes are not used often. Add indexes for faster queries.</p>

    <table class="table">
      <thead>
        <tr>
          <th>Table</th>
          <th>% of Time Index Used</th>
          <th>Rows in Table</th>
        </tr>
      </thead>
      <tbody>
        {% for object in missing_indexes %}
          <tr>
            <td>{{ object.table }}</td>
            <td style="width: 30%;">{{ object.percent_of_times_index_used }}</td>
            <td style="width: 20%;">{{ object.rows_in_table }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>

  <div class="module">
    <h2>Unused Indexes</h2>

    <p>Unused indexes cause unnecessary overhead. Remove them for faster writes.</p>

    <table class="table">
      <thead>
        <tr>
          <th>Name</th>
          <th>Index Size</th>
          <th>Index Scans</th>
        </tr>
      </thead>
      <tbody>
        {% for object in unused_indexes %}
          <tr class="{% cycle "row2" "row1" %}">
            <td>{{ object.index }}<div class="text-muted">on {{ object.table }}</div></td>
            <td style="width: 15%;">{{ object.index_size }}</td>
            <td style="width: 15%;">{{ object.index_scans }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>

  <div class="module">
    <h2>Unused Tables</h2>

    <table class="table">
      <thead>
        <tr>
          <th>Table</th>
          <th>Rows in Table</th>
        </tr>
      </thead>
      <tbody>
        {% for object in unused_tables %}
          <tr>
            <td>{{ object.table }}</td>
            <td style="width: 20%;">{{ object.rows_in_table }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock content %}
